package org.gcube.application.geoportal.service;

import org.bson.Document;
import org.gcube.application.cms.tests.model.concessioni.TestConcessioniModel;
import org.gcube.application.geoportal.common.model.document.ProfiledDocument;
import org.gcube.application.geoportal.common.model.document.lifecycle.LifecycleInformation;
import org.gcube.application.geoportal.common.model.rest.RegisterFileSetRequest;
import org.gcube.application.geoportal.common.model.rest.StepExecutionRequest;
import org.gcube.application.geoportal.common.rest.InterfaceConstants;
import org.gcube.application.geoportal.common.utils.StorageUtils;
import org.junit.Test;

import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Response;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

public class ProfiledConcessioniTests extends ProfiledDocumentsTests{


    @Override
    protected WebTarget baseTarget() {
        String testProfileId="profiledConcessioni";
        return target(InterfaceConstants.Methods.PROJECTS).path(testProfileId);
    }

    @Test
    public void testSDI() throws Exception {
        // Create new
        ProfiledDocument doc = createNew();
        // register filesets
        doc = upload(
                new StorageUtils(),
                doc.get_id(),
                "posizionamentoScavo.fileset",
                "posizionamentoScavo.children[?(@.fileset)]",
                Document.parse("{\"titolo\" : \"mio titolo\",\"some\" : \"something\" }"),
                RegisterFileSetRequest.ClashOptions.MERGE_EXISTING,
                "pos.shp");

        // invoke step SUBMIT-FOR-REVIEW
        StepExecutionRequest req=new StepExecutionRequest();
        req.setStepID("SUBMIT-FOR-REVIEW");
        doc=step(doc.get_id(),req);
        System.out.println(doc);
        assertTrue(doc.getLifecycleInformation().getLastOperationStatus().equals(LifecycleInformation.Status.OK));
    }
}
